# -*- coding: utf-8 -*-
import re
import json
import traceback
import datetime
import pdb

import dateutil
import dateutil.parser

import asyncio
import json
import dateutil.parser
from pyppeteer import launch
from pyppeteer.errors import TimeoutError, ElementHandleError
from amazon_reports_downloader.utils import extract_balance_amount


class SkuManager(object):
    def __init__(self, page, marketplace):
        self.page = page
        self.marketplace = marketplace.lower()

    async def is_element_visible(self, selector):
        element = await self.page.querySelector(selector)
        if not element:
            return False

        visible = await self.page.evaluate(
            '(element) => element.style.display !== "none"', element
        )
        return visible

    async def trigger_action(self):
        try:
            await self.page.evaluate(
                """() => document.querySelector("div#myitable div.mt-content tbody tr.mt-row td[data-column='action'] button[role='combobox']").click()"""
            )
        except:
            return False

        return True

    async def click_link_containing_text(self, container_selector, text):
        try:
            await self.page.evaluate(
                f"""(container_selector, text) => {{
                    const container = document.querySelector(container_selector);
                    if (container) {{
                        const links = container.querySelectorAll('a');
                        for (let link of links) {{
                            if (link.textContent.includes(text)) {{
                                link.click();
                                break;
                            }}
                        }}
                    }}
                }}
            """,
                container_selector,
                text,
            )
        except Exception as e:
            return False

        return True
